clear

c = 299792458;
u0 = 4*pi*1e-7;
e0 = 1/(c^2*u0);

f = 30e9;
lambda = c/f;
L = 5*lambda; %thickness of dielectric region
x = linspace(0,L,100); %x(1) = 0, x(m+1) = L. the length, minus 1, is the number of layers. 

er = 4+(2-j*0.1)*(1-x/L).^2;
ur = 2-j*0.1;
%er = linspace(1,1,1001);
%ur = 1;

%for p = 1:91
   theta = pi/2%(p-1)*pi/180
k = f*2*pi*sqrt(u0*e0)*sqrt(ur*er-sin(theta)^2);
R = zeros(1,length(x));
n = zeros(1,length(x));
R(1) = -1;

for i =1:length(R)-1
    n(i+1) = (ur*k(i+1)-ur*k(i))./(ur*k(i+1)+ur*k(i));
    R(i+1) = exp(2*j*k(i+1)*x(i+1)).*(n(i+1)+R(i).*exp(-2*j*k(i).*x(i+1)))/(1+n(i+1)*R(i).*exp(-2*j*k(i).*x(i+1)));
    
end



plot(x,R)
%angle = linspace(0,90,91)
%real(R(length(R)))
%plot(angle,Rmplus1)