n = 201
M=(n-1)/2
c=299792458;
u0=4*pi*1e-7;
e0=1/(c^2*u0);
k0 = sqrt(u0/e0);
f=30e9;
lambda=c/f;
L=5*lambda;
x = linspace(0,L,M+1); %x(1) = 0, x(m+1) = L. the length, minus 1, is the number of layers. 
y = linspace((x(2)+x(1))/2, (x(M+1)+x(M))/2,M); %this is the center of each layer.
er =-4+(-2-j*0.1)*(1-y/L).^2; %should be calculated in each layer, NOT at each node.
er(M+1) = 1;
ur = linspace(2-j*0.1,2-j*0.1,M);
ur(M+1) = 1;
angle = linspace(0,45,21)*pi/180;
%analytical
for p = 4
   theta = angle(p);
kx = f*2*pi*sqrt(u0*e0)*sqrt(ur.*er-sin(theta)^2);
if imag(kx(10)) >0
    kx = -kx;
end
R(1) = -1;
R1(1) = -1;
% %epol
for m =1:M-1 %to find the reflection coefficient at each boundary layer, before the boundary at the vacuum interface
    na(m+1) = (ur(m)*kx(m+1)-ur(m+1)*kx(m))./(ur(m)*kx(m+1)+ur(m+1)*kx(m));
     if real(na(m+1)) < 0 
         na(m+1) = -na(m+1);
     end
    R(m+1) = (na(m+1)-R(m).*exp(-2*j*kx(m).*x(m+1)))/(1-na(m+1)*R(m).*exp(-2*j*kx(m).*x(m+1))).*exp(2*j*kx(m+1)*x(m+1));
    
end
for m = M
    na(m+1) = -(ur(m)*kx(m+1)-ur(m+1)*kx(m))./(ur(m)*kx(m+1)+ur(m+1)*kx(m));
     R(m+1) = (na(m+1)-R(m).*exp(-2*j*kx(m).*x(m+1)))/(1+na(m+1)*R(m).*exp(-2*j*kx(m).*x(m+1))).*exp(2*j*kx(m+1)*x(m+1));
end   
Reng(p) = R(M+1);
end

%angle=linspace(0,90,n_thetas)*pi/180';
theta=angle*180/pi;
%edng = abs(Rdng - Rfemdng)./abs(Rdng)
%edps = abs(Rdps - Rfemdps)./abs(Rdps)
%emng = abs(Rmng - Rfemmng)./abs(Rmng)
eeng = abs(Reng - Rfemeng)./abs(Reng)
myPlot=figure(1)
%plot(angle*180/pi,abs(Rfemdps),'-',angle*180/pi,abs(Rfemdng),'o',angle*180/pi,abs(Rfemeng)\,'x-',angle*180/pi,abs(Rfemmng),'h-')
plot(angle*180/pi,abs(Rfemeng),angle*180/pi,abs(Reng))
ylabel('Reflection coefficient')
xlabel('Angle \theta [degrees]')
set(myPlot,'Position',[400,400,400,250])
%ylim([0,1])
xlim([0,90])
legend('FEM','analytical')
%legend('DPS','DNG','ENG','MNG')

% myPlot=figure(2)
% 
% semilogy(angle*180/pi,edps,angle*180/pi,edng,'o',angle*180/pi,eeng,'x-',angle*180/pi,emng,'h')
% legend('DPS','DNG','ENG','MNG')
% ylim([10^-5,1])
% ylabel('Relative error of reflection coefficient')
% xlabel('Angle \theta [degrees]')
% set(myPlot,'Position',[400,400,400,250])
% xlim([0,90])
% grid on
